<?php
namespace Compras\Logic\NecessidadeCompras;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;

class PeriodicidadeNaoCalculada
{


    /**
     * Executa procedure PERIODICIDADE_NAO_CALCULADA
     *
     * @param $nrorg
     * @param $filial
     * @param $grupo_filial
     * @param $prodinicial
     * @param $prodfinal
     * @throws \Exception
     */
    public function executaProcedurePeriodicidadeNaoCalculada($nrorg, $filial, $grupo_filial, $prodinicial, $prodfinal) {
        try {
            $procedure = new Procedure("PERIODICIDADE_NAO_CALCULADA"); //Procedure 'SF_PERIODICIDADE_NAO_CALCULADA'
            self::addParametrosPeriodicidadeNaoCalculada($procedure, $nrorg, $filial, $grupo_filial, $prodinicial, $prodfinal);
            $procedure->call();
        } catch (\Exception $e) {
            throw $e;
        }
    }


    /**
     * Adiciona os parametros da procedure PERIODICIDADE_NAO_CALCULADA.
     *
     * @static
     * @param Procedure $procedure Setforms2\Runtime\Helper\Procedure $procedure
     * @param $nrorg
     * @param $filial
     * @param $grupo_filial
     * @param $prodinicial
     * @param $prodfinal
     */
    protected static function addParametrosPeriodicidadeNaoCalculada(
        Procedure $procedure, $nrorg, $filial, $grupo_filial, $prodinicial, $prodfinal)
    {
//        $procedure->addParam(
//            new Param(
//                'P_NRORG',
//                Param::PARAM_INPUT,
//                $nrorg,
//                Param::PARAM_TYPE_INT
//            )
//        );
        $procedure->addParam(
            new Param(
                'P_CDFILIAL',
                Param::PARAM_INPUT,
                $filial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_TCDFILIAL',
                Param::PARAM_INPUT,
                '',
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDGRUPFILI',
                Param::PARAM_INPUT,
                $grupo_filial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDPRODINI',
                Param::PARAM_INPUT,
                $prodinicial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDPRODFIN',
                Param::PARAM_INPUT,
                $prodfinal,
                Param::PARAM_TYPE_STR
            )
        );
    }

}
